| OpenCV 3.4.8 Open Source Computer Vision

Namespaces | Classes | Functions
GUI for Interactive Visual Debugging of Computer Vision Programs

## Namespaces
| cvv::impl

## Classes
class | cvv::FinalShowCaller
| RAII-class to call finalShow() in it's dtor. More...

## Functions
static void | cvv::debugDMatch (cv::InputArray img1, std::vector< cv::KeyPoint > keypoints1, cv::InputArray img2, std::vector< cv::KeyPoint > keypoints2, std::vector< cv::DMatch > matches, const impl::CallMetaData &data, const char *description=nullptr, const char *view=nullptr, bool useTrainDescriptor=true)
| Add a filled in DMatch <dmatch> to debug GUI. More...
static void | cvv::debugDMatch (cv::InputArray img1, std::vector< cv::KeyPoint > keypoints1, cv::InputArray img2, std::vector< cv::KeyPoint > keypoints2, std::vector< cv::DMatch > matches, const impl::CallMetaData &data, const std::string &description, const std::string &view, bool useTrainDescriptor=true)
static void | cvv::debugFilter (cv::InputArray original, cv::InputArray result, impl::CallMetaData metaData=impl::CallMetaData(), const char *description=nullptr, const char *view=nullptr)
| Use the debug-framework to compare two images (from which the second is intended to be the result of a filter applied to the first). More...
static void | cvv::debugFilter (cv::InputArray original, cv::InputArray result, impl::CallMetaData metaData, const ::std::string &description, const ::std::string &view="")
static bool | cvv::debugMode ()
| Returns whether debug-mode is active for this TU and thread. More...
void | cvv::finalShow ()
| Passes the control to the debug-window for a last time. More...
static void | cvv::setDebugFlag (bool active)
| Enable or disable cvv for current translation unit and thread. More...
static void | cvv::showImage (cv::InputArray img, impl::CallMetaData metaData=impl::CallMetaData(), const char *description=nullptr, const char *view=nullptr)
| Add a single image to debug GUI (similar to imshow <>). More...
static void | cvv::showImage (cv::InputArray img, impl::CallMetaData metaData, const ::std::string &description, const ::std::string &view="")

## Detailed Description

Namespace for all functions is cvv, i.e. cvv::showImage().

Compilation:

- For development, i.e. for cvv GUI to show up, compile your code using cvv with g++ -DCVVISUAL_DEBUGMODE*.
- For release, i.e. cvv calls doing nothing, compile your code without above flag.

See cvv tutorial for a commented example application using cvv.

## Function Documentation

## § debugDMatch() [1/2]

static void cvv::debugDMatch | ( | cv::InputArray | img1,
|  | std::vector< cv::KeyPoint > | keypoints1,
|  | cv::InputArray | img2,
|  | std::vector< cv::KeyPoint > | keypoints2,
|  | std::vector< cv::DMatch > | matches,
|  | const impl::CallMetaData & | data,
|  | const char * | description = `nullptr`,
|  | const char * | view = `nullptr`,
|  | bool | useTrainDescriptor = `true`
| ) |  |
| inline static

`#include <opencv2/cvv/dmatch.hpp>`

Add a filled in DMatch <dmatch> to debug GUI.

The matches can are visualized for interactive inspection in different GUI views (one similar to an interactive :draw_matches:drawMatches<>).

Parameters

  img1 | First image used in DMatch <dmatch>.
  keypoints1 | Keypoints of first image.
  img2 | Second image used in DMatch.
  keypoints2 | Keypoints of second image.
  matches |
  data | See showImage
  description | See showImage
  view | See showImage
  useTrainDescriptor | Use DMatch <dmatch>'s train descriptor index instead of query descriptor index.

## § debugDMatch() [2/2]

static void cvv::debugDMatch | ( | cv::InputArray | img1,
|  | std::vector< cv::KeyPoint > | keypoints1,
|  | cv::InputArray | img2,
|  | std::vector< cv::KeyPoint > | keypoints2,
|  | std::vector< cv::DMatch > | matches,
|  | const impl::CallMetaData & | data,
|  | const std::string & | description,
|  | const std::string & | view,
|  | bool | useTrainDescriptor = `true`
| ) |  |
| inline static

`#include <opencv2/cvv/dmatch.hpp>`

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## § debugFilter() [1/2]

static void cvv::debugFilter | ( | cv::InputArray | original,
|  | cv::InputArray | result,
|  | impl::CallMetaData | metaData = `impl::CallMetaData()`,
|  | const char * | description = `nullptr`,
|  | const char * | view = `nullptr`
| ) |  |
| inline static

`#include <opencv2/cvv/filter.hpp>`

Use the debug-framework to compare two images (from which the second is intended to be the result of a filter applied to the first).

## § debugFilter() [2/2]

static void cvv::debugFilter | ( | cv::InputArray | original,
|  | cv::InputArray | result,
|  | impl::CallMetaData | metaData,
|  | const ::std::string & | description,
|  | const ::std::string & | view = `""`
| ) |  |
| inline static

`#include <opencv2/cvv/filter.hpp>`

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## § debugMode()

static bool cvv::debugMode | ( |  | ) |
| inline static

`#include <opencv2/cvv/debug_mode.hpp>`

Returns whether debug-mode is active for this TU and thread.

## § finalShow()

void cvv::finalShow | ( |  | ) |
| inline

`#include <opencv2/cvv/final_show.hpp>`

Passes the control to the debug-window for a last time.

This function must be called once after all cvv calls if any. As an alternative create an instance of FinalShowCaller, which calls finalShow() in its destructor (RAII-style).

## § setDebugFlag()

static void cvv::setDebugFlag | ( | bool | active | ) |
| inline static

`#include <opencv2/cvv/debug_mode.hpp>`

Enable or disable cvv for current translation unit and thread.

(disabled this way has higher - but still low - overhead compared to using the compile flags).

Parameters

  active |

## § showImage() [1/2]

static void cvv::showImage | ( | cv::InputArray | img,
|  | impl::CallMetaData | metaData = `impl::CallMetaData()`,
|  | const char * | description = `nullptr`,
|  | const char * | view = `nullptr`
| ) |  |
| inline static

`#include <opencv2/cvv/show_image.hpp>`

Add a single image to debug GUI (similar to imshow <>).

Parameters

  img | Image to show in debug GUI.
  metaData | Properly initialized CallMetaData struct, i.e. information about file, line and function name for GUI. Use CVVISUAL_LOCATION macro.
  description | Human readable description to provide context to image.
  view | Preselect view that will be used to visualize this image in GUI. Other views can still be selected in GUI later on.

## § showImage() [2/2]

static void cvv::showImage | ( | cv::InputArray | img,
|  | impl::CallMetaData | metaData,
|  | const ::std::string & | description,
|  | const ::std::string & | view = `""`
| ) |  |
| inline static

`#include <opencv2/cvv/show_image.hpp>`

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.